/*
 *  Gtk_CoordEntry.cc
 *
 *  Coordinate Entry widget
 *
 *  Copyright (C) 2002 Tobias Dyckerhoff
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */


#include "Gtk_CoordEntry.h"






CoordEntry::CoordEntry(const char* lab, int id):Table(2,4,false),coord(0,0,0),x_entry(6),y_entry(6),z_entry(6), x_label(" x "), y_label(" y "), z_label(" z "), label(lab)
{

  identifier=id;

  attach(label,0,2,0,1);

  attach(x_label,0,1,1,2);
  attach(y_label,0,1,2,3);
  attach(z_label,0,1,3,4);

  attach(x_entry,1,2,1,2);
  attach(y_entry,1,2,2,3);
  attach(z_entry,1,2,3,4);


  /* set minimum size of the entries. */

  x_entry.set_usize(50, -1);
  y_entry.set_usize(50, -1);
  z_entry.set_usize(50, -1);


  /* connecting... */

  x_entry.activate.connect(slot(this, &CoordEntry::on_entry_activated));
  y_entry.activate.connect(slot(this, &CoordEntry::on_entry_activated));
  z_entry.activate.connect(slot(this, &CoordEntry::on_entry_activated));

}



void CoordEntry::on_entry_activated()
{

  char st[10];
  int j;

  /* here the text entered is checked. only digits and '.' are allowed. */   

  /* should use strings in the future */

  for (j=0;j<(x_entry.get_text()).length();j++) st[j]=(x_entry.get_text())[j]; 
  st[j]=0;

  for (int i=0;i<=strlen(st)-1;i++)
    {
      if ((st[i]<48||st[i]>57)&&st[i]!='.'&&st[i]!='-')
	{
	  set_coord(coord);
	  return;
	}
    }
  coord[0]=atof(st);

 for (j=0;j<(y_entry.get_text()).length();j++) st[j]=(y_entry.get_text())[j]; 
  st[j]=0;


  for (int i=0;i<=strlen(st)-1;i++)
    {

      if ((st[i]<48||st[i]>57)&&st[i]!='.'&&st[i]!='-')
	{
	  set_coord(coord);
	  return;
	}
    }
  coord[1]=atof(st);

  for (j=0;j<(z_entry.get_text()).length();j++) st[j]=(z_entry.get_text())[j]; 
  st[j]=0;

  for (int i=0;i<=strlen(st)-1;i++)
    {
      if ((st[i]<48||st[i]>57)&&st[i]!='.'&&st[i]!='-')
	{
	  set_coord(coord);
	  return;
	}
    }
  coord[2]=atof(st);
  set_coord(coord);


  /* emit the signal */
  entry_activated(identifier);

}


int CoordEntry::get_id(){
  return identifier;
}


int CoordEntry::set_coord(Vector3 c)
{
  coord=c;
 
  char st[18];
  sprintf(st,"%lf",c[0]);
  x_entry.set_text(st);
  sprintf(st,"%lf",c[1]);
  y_entry.set_text(st);
  sprintf(st,"%lf",c[2]);
  z_entry.set_text(st);
  return 1;
}



Vector3 CoordEntry::get_coord()
{
  return coord;
}
