/*
 *  Gtk_PIntEntry.h
 *
 *  Positive Integer Entry widget
 *
 *  Copyright (C) 2002 Tobias Dyckerhoff
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */


#include "Gtk_PIntEntry.h"






PIntEntry::PIntEntry(const char* lab, int id):entry(6), label(lab)
{

  identifier=id;
  pack_start(label);

  /* set minimum size of the entry. */
  entry.set_usize(50, -1);

  /* connecting... */
  entry.activate.connect(slot(this, &PIntEntry::on_entry_activated));

  pack_start(entry);
}



void PIntEntry::on_entry_activated()
{

  char st[10];
  int j;

  /* here the text entered is checked. only digits are allowed. */   

  /* should use strings in the future */

  for (j=0;j<(entry.get_text()).length();j++) st[j]=(entry.get_text())[j]; 
  st[j]=0;

  for (int i=0;i<=strlen(st)-1;i++)
    {
      if (st[i]<48||st[i]>57)
	{
	  set_value(x);
	  return;
	}
    }
  x=atoi(st);

  set_value(x);

 /* emit the signal */
  entry_activated(identifier);
}

int PIntEntry::get_id(){
  return identifier;
}


int PIntEntry::set_value(unsigned int c)
{
  x=c;
 
  char st[18];
  sprintf(st,"%u",x); 
  entry.set_text(st);

  return 1;
}



unsigned int PIntEntry::get_value()
{
  return x;
}
